var imageyoffset = 20;
var refreshrate = 10000;
var mode = "view";
var mappingenabled = false;
var pointarr;
var confpointnum;

document.onmousedown=mousedown;
document.onmouseup=mouseup;

document.addEventListener('DOMContentLoaded', function(){
  //Either configuration mode or viewing mode
  mode = getQueryVariable("mode");

  //In configuration mode we push map down a bit further
  if(mode === "conf")
  {
    confpointnum = getQueryVariable("pointnum");
    imageyoffset = 50;

    //Show config bar and set hidden fields for sensor and readingnum
    document.getElementById("confbar").style.visibility="visible";
    document.getElementById("confsensorval").style.visibility="visible";
    document.getElementById("pointnum").value = confpointnum;
  }

  //Load image and pointdata
  loadMapImage();
  loadPointData();

  //In view mode reload data every 10s
  if(mode != "conf")
  {
    setInterval(loadPointData, refreshrate);
  } 
});

function loadMapImage(){

  //Load map data
  var xhttp = new XMLHttpRequest();
  var url = "../ajax/mapdata.json" + "?_=" + Math.floor(Math.random() * 1000000);
  
  xhttp.onreadystatechange = function() {
      if (this.readyState == 4){
        if(this.status == 200) {
          var resp = JSON.parse(xhttp.responseText);
          mappingenabled = resp.mappingEnabled;
          imagehtml = loadimage();
        } else {
          imagehtml = "Error loading map data."
        }
      document.getElementById("image").innerHTML = imagehtml;
     } 
  };
  xhttp.open("GET", url, true);
  xhttp.send(); 
}

function loadConfSensorData(){
  //Find point we're configuring
  for(var i=0; i< pointarr.length; i++)
  {
    if(pointarr[i].num == confpointnum)
    {
      point = pointarr[i];
      break;
    }
  }

  document.getElementById("sensordetails").innerHTML = point.details;
  confsensorval.innerHTML = "<span id='dragger' style='display: table-cell; vertical-align: middle;'>&nbsp;"+point.str+"&nbsp;</span>"
  confsensorval.style.top=(point.yloc + imageyoffset)+"px";
  confsensorval.style.left=point.xloc+"px";
  confsensorval.style.width=point.xsize+"px";
  confsensorval.style.height=point.ysize+"px";
  confsensorval.style.fontSize=point.fontsize+"pt";
  document.getElementById('locx').value = parseInt(point.xloc);
  document.getElementById('locy').value = parseInt(point.yloc);
  document.getElementById('sizex').value = parseInt(point.xsize);
  document.getElementById('sizey').value = parseInt(point.ysize);
  document.getElementById('fontsize').value = parseInt(point.fontsize);
}

function loadimage()
{
  if(mappingenabled)
   return '<IMG id="mapimg" STYLE="top:' + imageyoffset + 'px; left:0px;" SRC="../floormap.jpg?_=' + Math.floor(Math.random() * 1000000)+ '" />'
  else
   return '<IMG id="mapimg" STYLE="position: relative; display: block; margin-left: auto; margin-right: auto;" SRC="images/mappingdisabled.jpg" />'
}

function loadPointData(){

  //Load map data
  var xhttp = new XMLHttpRequest();
  var url = "../ajax/mapdata.json" + "?_=" + Math.floor(Math.random() * 1000000);
  var pointshtml = "";

  xhttp.onreadystatechange = function() {
      if (this.readyState == 4){
        if(this.status == 200) {
          var resp = JSON.parse(xhttp.responseText);
          pointarr = resp.pointsList;
          //Refresh image if mapping becomes disabled
          if(resp.mappingEnabled != mappingenabled)
          {
            mappingenabled = resp.mappingEnabled;
            imagehtml = loadimage();
            document.getElementById("image").innerHTML = imagehtml;
          }
          //Load points if mapping is enabled
          if(resp.mappingEnabled)
          {
            pointshtml = loadpoints(pointarr);

            //In configuration mode one point is treated special
            if(mode === "conf")
              loadConfSensorData();
          } 
        } else {
          pointshtml = "Error loading map data."
        }
      document.getElementById("pointsoverlay").innerHTML = pointshtml;

      //In configuration mode we don't have a timestamp
      if(mode != "conf") 
        document.getElementById("timestamp").innerHTML = timestamp();
     } 
  };
  xhttp.open("GET", url, true);
  xhttp.send(); 

}

function timestamp()
{
  var currentTime = new Date();
	var hours = currentTime.getHours();
	var minutes = currentTime.getMinutes();
	var seconds = currentTime.getSeconds();
	var month = currentTime.getMonth() + 1;
	var date = currentTime.getDate();
	var year = currentTime.getFullYear();
  var timestamp = "";

  if (typeof this.count == 'undefined' ) {
    this.count = 0;
  }
  
  this.count++;

	if (minutes < 10)
    minutes = "0" + minutes;

	if (seconds < 10)
    seconds = "0" + seconds;

	timestamp = "Map data refreshed at: " + month + "/" + date + "/" + year + " " + hours + ":" + minutes + ":" + seconds + " (" + this.count +")";

  return timestamp;
}

//Load image and map content based on resp contents
function loadpoints(pointsList)
{
  pointshtml = "";

  for(var i = 0; i < pointsList.length; i++)
  {
    if(mode === "conf" && pointsList[i].num == confpointnum)
      continue;

    pointshtml += addpoint(pointsList[i]);
  }

  return pointshtml;
}


function addpoint(point)
{
  point.yloc += imageyoffset;

  //Convert for web
  ConvPointDataForWeb(point);

  ret = "";
  ret += '<div class="t" onmouseover="showmenu(\'in' + point.num + '\')" onmouseout="hidemenu(\'in' + point.num + '\')" style="top:' + point.yloc + 'px; left:' + point.xloc + 'px; '

  //If conf mode make clickable to configure
  if(mode === "conf")
    ret += 'cursor: pointer; " onclick="switchToEditPoint('+point.num+')" >'
  else
    ret += '" >'
  
  ret += ' <table height=' + point.ysize +' width=' + point.xsize + '><tr><td bgcolor=' + point.color + ' class="reading" style="font-size: ' + point.fontsize + 'pt;">&nbsp;' + point.str + '&nbsp;</td></table></div>'
  ret += ' <table class="label" id="in' + point.num + '" style="top:' + (point.yloc+point.ysize + 10) + 'px; left:' + point.xloc + 'px;"> <tr><td>' + point.details + '</td></tr> </table>'

  return ret;
}

function switchToEditPoint(pointnum)
{
  //Save current point
  saveChanges(pointnum);

  //Change to edit new pointnum
  //window.location.search="?mode=conf&pointnum="+pointnum
}

function ConvPointDataForWeb(point)
{
  //Replace degF or degC with degree symbol
  if(point.str)
  {
    point.str = point.str.replace(/deg([C|F])/g, "&deg;$1");
  }
}

function showmenu(elmnt)
{
document.getElementById(elmnt).style.visibility="visible";
}
function hidemenu(elmnt)
{
document.getElementById(elmnt).style.visibility="hidden";
}

function mousedown(e)
{
if (e == null) { e = window.event;}
var sender = (typeof( window.event ) != "undefined" ) ? e.srcElement : e.target;

if (sender.id=="dragger")
  {
  mouseover=true;
  confsensorval = document.getElementById("confsensorval");
  locx = document.getElementById("locx");
  locy = document.getElementById("locy");

  pleft=parseInt(confsensorval.style.left);
  ptop=parseInt(confsensorval.style.top);
  xcoor=e.clientX;
  ycoor=e.clientY;
  document.onmousemove= function(e) {
    if (e == null) { e = window.event;}
    //Calculate new location, don't let it go outside the top left
    newleft = pleft+e.clientX-xcoor;
    newtop = ptop+e.clientY-ycoor;
    if(newleft < 1)
      newleft = 1;
    if(newtop < imageyoffset+1)
      newtop = imageyoffset+1;

    confsensorval.style.left=newleft + "px";
    confsensorval.style.top=newtop + "px";
    locx.value = newleft;
    locy.value = newtop - imageyoffset;
    return false;
  }
  return false;
  }
else { return true; }
}

function mouseup(e)
{
confsensorval = document.getElementById("confsensorval");
document.getElementById('locx').value = parseInt(confsensorval.style.left);
document.getElementById('locy').value = parseInt(confsensorval.style.top)-imageyoffset;
document.onmousemove=null;
}

function valchange()
{
  newleft = parseInt(document.getElementById('locx').value);
  newtop = parseInt(document.getElementById('locy').value) + imageyoffset;

  if(newleft < 1)
    newleft = 1;
  if(newtop < imageyoffset+1)
    newtop = imageyoffset+1;

  confsensorval = document.getElementById("confsensorval");
  confsensorval.style.width = parseInt(document.getElementById('sizex').value) + "px";
  confsensorval.style.height = parseInt(document.getElementById('sizey').value) + "px";
  confsensorval.style.left = newleft + "px";
  confsensorval.style.top = newtop + "px";
  confsensorval.style.fontSize = parseInt(document.getElementById('fontsize').value) + "pt";
}

function saveChanges(changeToPointnum){
  document.getElementById('saveresult').innerHTML="Error.";
  document.getElementById('saveresult').style.color="red";

  //Get sensor and reading num
  var sensorform = document.getElementById("mapconf");

  //Make ajax call
  var xmlhttp = new XMLHttpRequest();
  var url = "map/pointedit";

  console.log("Editing point");
  xmlhttp.onreadystatechange=function() {
    if (xmlhttp.readyState == 4)
    {
      if(xmlhttp.status == 200) {
        document.getElementById('saveresult').innerHTML="Saved.";
        document.getElementById('saveresult').style.color="green";

        //If changing to edit a newpointnum do that now
        if(typeof changeToPointnum != 'undefined')
        {
          confpointnum = changeToPointnum
          document.getElementById("pointnum").value = changeToPointnum;
          window.history.replaceState(null, "", "?mode=conf&pointnum="+changeToPointnum);
          loadPointData();
        }
      } else {
        document.getElementById("saveresult").innerHTML = "Saving point...Error!";
        document.getElementById("saveresult").style.color = "red";
      }
    }
  }
  document.getElementById("saveresult").innerHTML = "Saving point...";
  document.getElementById("saveresult").style.color = "black";
  xmlhttp.open("POST", url, true);
  xmlhttp.send(new FormData(sensorform));
}


function getQueryVariable(variable) {
	var query = window.location.search.substring(1);
	var vars = query.split("&");
	for (var i=0;i<vars.length;i++) {
		var pair = vars[i].split("=");
		if(pair[0] == variable){return pair[1];}
	}
	return(false);
}
